/*
 * LOGICAL-PARADOX.ORG
 * Copyright (C)2005 satoshi akabane(akabane@logical-paradox.org)
 * $Id: DisposeDatabaseCommand.java,v 1.2 2005/09/07 13:38:06 rampil Exp $
 */
package org.logical_paradox.vsan.dac.command.handler;

import java.io.IOException;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.logical_paradox.common.session.IllegalSessionStateException;
import org.logical_paradox.common.session.Session;
import org.logical_paradox.vsan.dac.DacConstant;
import org.logical_paradox.vsan.dac.NodeContext;
import org.logical_paradox.vsan.dac.Response;
import org.logical_paradox.vsan.dac.ResponseCode;
import org.logical_paradox.vsan.dac.command.exception.CommandExecutionException;
import org.logical_paradox.vsan.dac.command.exception.SessionTerminationException;
import org.logical_paradox.vsan.node.Database;

/**
 * ドメインデータベースファイル削除コマンド
 * @author satoshi akabane@logical-paradox.org
 * @version $Revision: 1.2 $
 */
public class DisposeDatabaseCommand implements DacCommand {
	/** ロガー */
	private static final Log log = LogFactory.getLog(DisposeDatabaseCommand.class);

	/**
	 * コマンドを実行する
	 * @param session 実行するセッション
	 * @return 更新されたセッション
	 * @throws CommandExecutionException コマンド実行中に発生した例外
	 * @throws SessionTerminationException 接続終了時に発生する例外
	 */
	public Session execute(Session session) throws CommandExecutionException, SessionTerminationException {
		try {
			NodeContext ctx = (NodeContext) session.getAttribute(DacConstant.SKEY_NODE_CONTEXT);
			Database db = ctx.getDatabase();

			// ドメインデータベースの破棄
			Response r = null;
			try {
				db.dispose();
				r = new Response(ResponseCode.OK, new byte[0]);
			} catch(IOException e) {
				log.warn("ドメインデータベースの削除に失敗しました: ", e);
				// ドメインデータベースの削除に失敗した
				r = new Response(ResponseCode.DATAFILE_WRITE_ERROR, new byte[0]);
			}

			// コマンドからの戻り値格納
			session.setAttribute(DacConstant.SKEY_DAC_RESPONSE, r);
			return session;
		} catch (IllegalSessionStateException e) {
			// セッションが継続可能な状態でない場合，当該セッションを終了する
			log.warn("ドメインデータベースの破棄が要求されましたが、セッションが持続可能な状態ではありませんでした。");
			log.warn("セッションを破棄します。");
			throw new SessionTerminationException(e);
		}
	}

}
